找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1336|回复: 0

[分享] Pinvoke acedSetFunHelp in ACAD2015

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-8-1 19:41:45 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
Pinvoke acedSetFunHelp in ACAD2015                             We have been recieving few queries from our ADN partners regarding setting help message display on F1 click on custom commands that
    The call to the function acedSetFunHelp always passes the value 0 (zero) as the cmd parameter.
     Has the call to the acedSetFunHelp function changed in the 2015 release and is it different between the 32bit and 64bit versions?
Yes, there has been change in the entry points of the function acedSetFunHelp and is different between 32/64 bit machines.
I have already answered this in forum post acedSetFunHelp , as to reach larger audience I planned to blog this with minor additions ,thanks to Alexander Rivilis for bringing up this issue ,used his part of code.

#define AUTOCAD_NEWER_THAN_2012
#define AUTOCAD_NEWER_THAN_2014
using System;
using System.Reflection;
using System.Diagnostics;
using System.IO;
using System.Runtime.InteropServices;
using cad = Autodesk.AutoCAD.ApplicationServices.Application;
using Ap = Autodesk.AutoCAD.ApplicationServices;
using Db = Autodesk.AutoCAD.DatabaseServices;
using Ed = Autodesk.AutoCAD.EditorInput;
using Rt = Autodesk.AutoCAD.Runtime;
[assembly: Rt.CommandClass(typeof(Help.Commands))]
namespace Help
{
    ///<summary>
    /// Help File
    ///</summary>
    public sealed class Commands
    {
        #region PInvoke
        #if AUTOCAD_NEWER_THAN_2012
        const String fnc_location = "accore.dll";
        #else
        const String fnc_location = "acad.exe";
        #endif
        #if AUTOCAD_NEWER_THAN_2014
        const String x86_Prefix = "_";
        #else
        const String x86_Prefix = "";
        #endif
        #region acedSetFunHelp
        const String acedSetFunHelp_Name = "acedSetFunHelp";
        [DllImport(fnc_location, CharSet = CharSet.Auto,
        CallingConvention = CallingConvention.Cdecl,
        private static extern Int32 acedSetFunHelp_x64(
        String functionName,
        String helpFile,
        String helpTopic,
        Int32 cmd);
        [DllImport(fnc_location, CharSet = CharSet.Auto,
        CallingConvention = CallingConvention.Cdecl,
        private static extern Int32 acedSetFunHelp_x86(
                                    String functionName,
                                    String helpFile,
                                    String helpTopic,
                                    Int32 cmd);
        internal static Int32 acedSetFunHelp(
                                    String functionName,
                                    String helpFile,
                                    String helpTopic,
                                    Int32 cmd)
        {
            if (IntPtr.Size == 4)
                return acedSetFunHelp_x86(functionName,
                                          helpFile,
                                          helpTopic,
                                          cmd);
            else
                return acedSetFunHelp_x64(functionName,
                                          helpFile,
                                          helpTopic,
                                          cmd);
        }
        #endregion // acedSetFunHelp
        #endregion // PInvoke
        const String commandGroup = "MyCommand";
        internal const String throughAcedSetFunHelp =         "ThroughAcedSetFunHelp";
        const String helpPageExtension = ".htm";
        /*Place the Chm file where .NET dll is resourced*/
        const String chmFileName = "MyHelp.chm";
        internal static readonly String asm_location =
        Path.GetDirectoryName(Assembly.GetExecutingAssembly()
        .Location);
        // chm-file is in the directory of dll-file.
        internal static readonly String chmFileFullName =
        Path.Combine(asm_location, chmFileName);
        const String f1_msg =
        "\nPress F1 for opening of " +
        "help system.\n";
        ///<summary>
        ///<summary>
        /// Registaration with calling acedSetFunHelp
        ///</summary>
        [Rt.CommandMethod(commandGroup,
                          throughAcedSetFunHelp,
                          Rt.CommandFlags.Session
        public void ThroughAcedSetFunHelp_Command()
        {
            Ap.Document doc =
            cad.DocumentManager.MdiActiveDocument;
            if (null == doc)
            {
                return;
            }
            string CmdName = "c:" +
                             throughAcedSetFunHelp.ToUpper();
            acedSetFunHelp(CmdName, chmFileFullName, "", 0);
            doc.Editor.GetPoint(f1_msg);
        }
    }
}



论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-12-19 00:18 , Processed in 0.375725 second(s), 28 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表